import { Quality } from "@interfaces/api";
import VideoTrending from "@interfaces/api/trending";

interface Channel {
	author: string;
	authorId: string;
	authorUrl: string;
	authorBanners: AuthorBanner[];
	authorThumbnails: AuthorBanner[];
	subCount: number;
	totalViews: number;
	joined: number;
	autoGenerated: boolean;
	isFamilyFriendly: boolean;
	description: string;
	descriptionHtml: string;
	allowedRegions: string[];
	latestVideos: VideoTrending[];
	relatedChannels: RelatedChannel[];
}

interface AuthorBanner {
	url: string;
	width: number;
	height: number;
	quality?: Quality;
}

interface RelatedChannel {
	author: string;
	authorId: string;
	authorUrl: string;
	authorThumbnails: AuthorBanner[];
}

export default Channel;
